Gentoo Websites Logo
Go to: Gentoo Home Documentation Forums Lists Bugs Planet Store Wiki Get Gentoo!
Bug 336801 - x11-libs/qt-gui-4.6.3[gtk]: fails to rebuild with x11-libs/cairo[qt4]
Summary: x11-libs/qt-gui-4.6.3[gtk]: fails to rebuild with x11-libs/cairo[qt4]
Status: RESOLVED FIXED
Alias: None
Product: Gentoo Linux
Classification: Unclassified
Component: [OLD] Unspecified (show other bugs)
Hardware: All Linux
: Highest major (vote)
Assignee: Qt Bug Alias
URL:
Whiteboard:
Keywords: InVCS
: 338283 338298 338479 338774 (view as bug list)
Depends on: 341703
Blocks:
  Show dependency tree
 
Reported: 2010-09-11 10:05 UTC by Harald van Dijk (RETIRED)
Modified: 2010-11-13 22:08 UTC (History)
24 users (show)

See Also:
Package list:
Runtime testing required: ---


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Harald van Dijk (RETIRED) gentoo-dev 2010-09-11 10:05:33 UTC
[...]
i686-pc-linux-gnu-g++ -c -march=native -g -O2 -pipe -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -I/usr/include/freetype2 -pthread -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -pthread -DQT_SHARED -I/usr/include/gtk-2.0 -I/usr/lib/gtk-2.0/include -I/usr/include/atk-1.0 -I/usr/include/cairo -I/usr/include/pango-1.0 -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -I/usr/include/pixman-1 -I/usr/include/freetype2 -I/usr/include/libpng14 -I/usr/include/qt4 -I/usr/include/qt4/QtGui -I/usr/include/qt4/QtCore -fvisibility=hidden -fvisibility-inlines-hidden -Wall -W -D_REENTRANT -I/usr/include/freetype2 -fPIC -DQT_SHARED -DQT_BUILD_GUI_LIB -DQT_NO_USING_NAMESPACE -DQT_NO_CAST_TO_ASCII -DQT_ASCII_CAST_WARNINGS -DQT_MOC_COMPAT -DQT_HAVE_MMX -DQT_HAVE_3DNOW -DQT_HAVE_SSE -DQT_HAVE_MMXEXT -DQT_HAVE_SSE2 -DQT_NO_OPENTYPE -DQT_NO_STYLE_MAC -DQT_NO_STYLE_WINDOWSVISTA -DQT_NO_STYLE_WINDOWSXP -DQT_NO_STYLE_WINDOWSCE -DQT_NO_STYLE_WINDOWSMOBILE -DQT_NO_STYLE_S60 -DQ_INTERNAL_QAPP_SRC -DQT_NO_DEBUG -DQT_CORE_LIB -D_LARGEFILE64_SOURCE -D_LARGEFILE_SOURCE -I../../mkspecs/linux-g++ -I. -I../../include/QtCore -I../../include -I../../include/QtGui -I.rcc/release-shared -I../3rdparty/xorg -I/usr/include/freetype2 -I../3rdparty/harfbuzz/src -Idialogs -I.moc/release-shared -I/usr/X11R6/include -I.uic/release-shared -o .obj/release-shared/moc_qgtkstyle.o .moc/release-shared/moc_qgtkstyle.cpp
.moc/release-shared/moc_qgtkstyle.cpp:48:19: error: ‘QGtkStyle’ has not been declared
.moc/release-shared/moc_qgtkstyle.cpp:57:20: error: ‘QGtkStyle’ has not been declared
.moc/release-shared/moc_qgtkstyle.cpp:57:44: error: non-member function ‘const QMetaObject* metaObject()’ cannot have cv-qualifier
/usr/include/qt4/QtCore/qobject.h: In function ‘const QMetaObject* metaObject()’:
/usr/include/qt4/QtCore/qobject.h:296:33: error: ‘QScopedPointer<QObjectData> QObject::d_ptr’ is protected
.moc/release-shared/moc_qgtkstyle.cpp:59:21: error: within this context
/usr/include/qt4/QtCore/qobject.h:296:33: error: invalid use of non-static data member ‘QObject::d_ptr’
.moc/release-shared/moc_qgtkstyle.cpp:59:21: error: from this location
/usr/include/qt4/QtCore/qobject.h:296:33: error: ‘QScopedPointer<QObjectData> QObject::d_ptr’ is protected
.moc/release-shared/moc_qgtkstyle.cpp:59:50: error: within this context
/usr/include/qt4/QtCore/qobject.h:296:33: error: invalid use of non-static data member ‘QObject::d_ptr’
.moc/release-shared/moc_qgtkstyle.cpp:59:50: error: from this location
.moc/release-shared/moc_qgtkstyle.cpp: At global scope:
.moc/release-shared/moc_qgtkstyle.cpp:62:7: error: ‘QGtkStyle’ has not been declared
.moc/release-shared/moc_qgtkstyle.cpp: In function ‘void* qt_metacast(const char*)’:
.moc/release-shared/moc_qgtkstyle.cpp:66:47: error: expected type-specifier before ‘QGtkStyle’
.moc/release-shared/moc_qgtkstyle.cpp:66:47: error: expected ‘>’ before ‘QGtkStyle’
.moc/release-shared/moc_qgtkstyle.cpp:66:47: error: expected ‘(’ before ‘QGtkStyle’
.moc/release-shared/moc_qgtkstyle.cpp:66:47: error: ‘QGtkStyle’ was not declared in this scope
.moc/release-shared/moc_qgtkstyle.cpp:66:57: error: expected primary-expression before ‘>’ token
.moc/release-shared/moc_qgtkstyle.cpp:66:59: error: invalid use of ‘this’ in non-member function
.moc/release-shared/moc_qgtkstyle.cpp:66:65: error: expected ‘)’ before ‘;’ token
.moc/release-shared/moc_qgtkstyle.cpp:67:49: error: cannot call member function ‘virtual void* QCleanlooksStyle::qt_metacast(const char*)’ without object
.moc/release-shared/moc_qgtkstyle.cpp: At global scope:
.moc/release-shared/moc_qgtkstyle.cpp:70:5: error: ‘QGtkStyle’ has not been declared
.moc/release-shared/moc_qgtkstyle.cpp: In function ‘int qt_metacall(QMetaObject::Call, int, void**)’:
.moc/release-shared/moc_qgtkstyle.cpp:72:52: error: cannot call member function ‘virtual int QCleanlooksStyle::qt_metacall(QMetaObject::Call, int, void**)’ without object
.moc/release-shared/moc_qgtkstyle.cpp:77:77: error: expected type-specifier before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:77:77: error: expected ‘>’ before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:77:77: error: expected ‘(’ before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:77:93: error: expected primary-expression before ‘)’ token
.moc/release-shared/moc_qgtkstyle.cpp:77:93: error: ‘StandardPixmap’ was not declared in this scope
.moc/release-shared/moc_qgtkstyle.cpp:79:77: error: expected type-specifier before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:79:77: error: expected ‘>’ before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:79:77: error: expected ‘(’ before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:79:93: error: expected primary-expression before ‘)’ token
.moc/release-shared/moc_qgtkstyle.cpp:79:93: error: ‘StandardPixmap’ was not declared in this scope
.moc/release-shared/moc_qgtkstyle.cpp: In function ‘void* qt_metacast(const char*)’:
.moc/release-shared/moc_qgtkstyle.cpp:68:1: warning: control reaches end of non-void function
.moc/release-shared/moc_qgtkstyle.cpp: In function ‘const QMetaObject* metaObject()’:
.moc/release-shared/moc_qgtkstyle.cpp:60:1: warning: control reaches end of non-void function
make: *** [.obj/release-shared/moc_qgtkstyle.o] Error 1
emake failed

emerge --info:
Portage 2.2_rc78 (default/linux/x86/10.0, gcc-4.5.1, glibc-2.12.1-r1, 2.6.35-gentoo-r5 i686)
=================================================================
System uname: Linux-2.6.35-gentoo-r5-i686-AMD_Athlon-tm-_64_X2_Dual_Core_Processor_4200+-with-gentoo-2.0.1
Timestamp of tree: Fri, 10 Sep 2010 15:45:01 +0000
app-shells/bash:     4.1_p7
dev-lang/python:     2.6.5-r3, 3.1.2-r4
dev-util/cmake:      2.8.1-r2
sys-apps/baselayout: 2.0.1
sys-apps/openrc:     0.6.3
sys-apps/sandbox:    2.3-r1
sys-devel/autoconf:  2.13, 2.67
sys-devel/automake:  1.10.3, 1.11.1
sys-devel/binutils:  2.20.1-r1
sys-devel/gcc:       4.5.1
sys-devel/gcc-config: 1.4.1
sys-devel/libtool:   2.2.10
sys-devel/make:      3.81-r2
virtual/os-headers:  2.6.35 (sys-kernel/linux-headers)
ACCEPT_KEYWORDS="x86 ~x86"
ACCEPT_LICENSE="* -@EULA AdobeFlash-10.1"
CBUILD="i686-pc-linux-gnu"
CFLAGS="-march=native -g -O2 -pipe"
CHOST="i686-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/X11/xkb /var/qmail/alias /var/qmail/control"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/portage /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-march=native -g -O2 -pipe"
DISTDIR="/usr/portage/distfiles"
EMERGE_DEFAULT_OPTS="--oneshot --verbose --with-bdeps=y"
FEATURES="assume-digests distlocks fixlafiles fixpackages news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch"
GENTOO_MIRRORS="http://ftp.snt.utwente.nl/pub/os/linux/gentoo"
LANG="en_GB.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/etc/portage/overlay/cross /etc/portage/overlay"
SYNC="rsync://rsync.nl.gentoo.org/gentoo-portage"
USE="X acl alsa berkdb bzip2 cdparanoia cli consolekit cracklib crypt cups cxx dbus dri drm flac fuse gallium gdbm gnome gnutls gpm gtk iconv ipv6 lightning mailwrapper mbox modules ncurses nls normalize nptl nptlonly pam pcre perl policykit pppd python qt4 readline reflection session ssl sysfs tcpd unicode x86 xorg zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1 emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" ELIBC="glibc" INPUT_DEVICES="evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" RUBY_TARGETS="ruby18" USERLAND="GNU" VIDEO_CARDS="nouveau" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account" 
Unset:  CPPFLAGS, CTARGET, FFLAGS, INSTALL_MASK, LC_ALL, LINGUAS, MAKEOPTS, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS

This is happening because of the -I/usr/include/qt4 -I/usr/include/qt4/QtGui -I/usr/include/qt4/QtCore, which get used over the qconfig.h from the build tree. The -I/usr/include/qt4 -I/usr/include/qt4/QtGui -I/usr/include/qt4/QtCore comes from pkg-config gtk+-2.0 --cflags:
# pkg-config gtk+-2.0 --cflags
-pthread -DQT_SHARED -I/usr/include/gtk-2.0 -I/usr/lib/gtk-2.0/include -I/usr/include/atk-1.0 -I/usr/include/cairo -I/usr/include/pango-1.0 -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -I/usr/include/pixman-1 -I/usr/include/freetype2 -I/usr/include/libpng14 -I/usr/include/qt4 -I/usr/include/qt4/QtGui -I/usr/include/qt4/QtCore
which, as in the summary, comes from cairo.
Comment 1 Davide Pesavento gentoo-dev 2010-09-11 20:29:39 UTC
Apart from the include paths issue, it seems we have a cyclic dep between cairo[qt4] and qt-gui[gtk], right?
Comment 2 Harald van Dijk (RETIRED) gentoo-dev 2010-09-11 21:20:19 UTC
Right, which means this may cause problems for a fresh Gentoo install using the default flags of the desktop profile.
Comment 3 Keith Harrison 2010-09-13 05:08:02 UTC
I get a similar error when trying to recompile qt-gui:

x86_64-pc-linux-gnu-g++ -c -O2 -march=core2 -pipe -fomit-frame-pointer -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -I/usr/include/freetype2 -pthread -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -pthread -DQT_SHARED -I/usr/include/gtk-2.0 -I/usr/lib64/gtk-2.0/include -I/usr/include/atk-1.0 -I/usr/include/cairo -I/usr/include/pango-1.0 -I/usr/include/glib-2.0 -I/usr/lib64/glib-2.0/include -I/usr/include/pixman-1 -I/usr/include/freetype2 -I/usr/include/libpng14 -I/usr/include/qt4 -I/usr/include/qt4/QtGui -I/usr/include/libdrm -I/usr/include/qt4/QtCore -fvisibility=hidden -fvisibility-inlines-hidden -Wall -W -D_REENTRANT -I/usr/include/freetype2 -fPIC -DQT_SHARED -DQT_BUILD_GUI_LIB -DQT_NO_USING_NAMESPACE -DQT_NO_CAST_TO_ASCII -DQT_ASCII_CAST_WARNINGS -DQT3_SUPPORT -DQT_MOC_COMPAT -DQT_HAVE_MMX -DQT_HAVE_3DNOW -DQT_HAVE_SSE -DQT_HAVE_MMXEXT -DQT_HAVE_SSE2 -DQT_NO_OPENTYPE -DQT_NO_STYLE_MAC -DQT_NO_STYLE_WINDOWSVISTA -DQT_NO_STYLE_WINDOWSXP -DQT_NO_STYLE_WINDOWSCE -DQT_NO_STYLE_WINDOWSMOBILE -DQT_NO_STYLE_S60 -DQ_INTERNAL_QAPP_SRC -DQT_NO_DEBUG -DQT_CORE_LIB -D_LARGEFILE64_SOURCE -D_LARGEFILE_SOURCE -I../../mkspecs/linux-g++ -I. -I../../include/QtCore -I../../include -I../../include/QtGui -I.rcc/release-shared -I../3rdparty/xorg -I/usr/include/freetype2 -I../3rdparty/harfbuzz/src -Idialogs -I.moc/release-shared -I/usr/X11R6/include -I.uic/release-shared -o .obj/release-shared/moc_qgtkstyle_p.o .moc/release-shared/moc_qgtkstyle_p.cpp
.moc/release-shared/moc_qgtkstyle_p.cpp:12:2: error: #error "The header file 'qgtkstyle_p.h' doesn't include <QObject>."
.moc/release-shared/moc_qgtkstyle_p.cpp:43: error: ‘QMetaObject’ does not name a type
.moc/release-shared/moc_qgtkstyle_p.cpp:52: error: expected initializer before ‘*’ token
.moc/release-shared/moc_qgtkstyle_p.cpp:57: error: ‘QGtkStyleUpdateScheduler’ has not been declared
.moc/release-shared/moc_qgtkstyle_p.cpp: In function ‘void* qt_metacast(const char*)’:
.moc/release-shared/moc_qgtkstyle_p.cpp:60: error: ‘strcmp’ was not declared in this scope
.moc/release-shared/moc_qgtkstyle_p.cpp:61: error: expected type-specifier before ‘QGtkStyleUpdateScheduler’
.moc/release-shared/moc_qgtkstyle_p.cpp:61: error: expected ‘>’ before ‘QGtkStyleUpdateScheduler’
.moc/release-shared/moc_qgtkstyle_p.cpp:61: error: expected ‘(’ before ‘QGtkStyleUpdateScheduler’
.moc/release-shared/moc_qgtkstyle_p.cpp:61: error: ‘QGtkStyleUpdateScheduler’ was not declared in this scope
.moc/release-shared/moc_qgtkstyle_p.cpp:61: error: expected primary-expression before ‘>’ token
.moc/release-shared/moc_qgtkstyle_p.cpp:61: error: invalid use of ‘this’ in non-member function
.moc/release-shared/moc_qgtkstyle_p.cpp:61: error: expected ‘)’ before ‘;’ token
.moc/release-shared/moc_qgtkstyle_p.cpp:62: error: ‘QObject’ has not been declared
.moc/release-shared/moc_qgtkstyle_p.cpp: At global scope:
.moc/release-shared/moc_qgtkstyle_p.cpp:65: error: ‘QGtkStyleUpdateScheduler’ has not been declared
.moc/release-shared/moc_qgtkstyle_p.cpp:65: error: ‘QMetaObject’ has not been declared
.moc/release-shared/moc_qgtkstyle_p.cpp:65: error: expected primary-expression before ‘int’
.moc/release-shared/moc_qgtkstyle_p.cpp:65: error: expected primary-expression before ‘void’
.moc/release-shared/moc_qgtkstyle_p.cpp:65: error: initializer expression list treated as compound expression
.moc/release-shared/moc_qgtkstyle_p.cpp:66: error: expected ‘,’ or ‘;’ before ‘{’ token
make: *** [.obj/release-shared/moc_qgtkstyle_p.o] Error 1
make: *** Waiting for unfinished jobs....
.moc/release-shared/moc_qgtkstyle.cpp:48: error: ‘QGtkStyle’ has not been declared
.moc/release-shared/moc_qgtkstyle.cpp:57: error: ‘QGtkStyle’ has not been declared
.moc/release-shared/moc_qgtkstyle.cpp:57: error: non-member function ‘const QMetaObject* metaObject()’ cannot have cv-qualifier
/usr/include/qt4/QtCore/qobject.h: In function ‘const QMetaObject* metaObject()’:
/usr/include/qt4/QtCore/qobject.h:296: error: ‘QScopedPointer<QObjectData, QScopedPointerDeleter<QObjectData> > QObject::d_ptr’ is protected
.moc/release-shared/moc_qgtkstyle.cpp:59: error: within this context
/usr/include/qt4/QtCore/qobject.h:296: error: invalid use of non-static data member ‘QObject::d_ptr’
.moc/release-shared/moc_qgtkstyle.cpp:59: error: from this location
/usr/include/qt4/QtCore/qobject.h:296: error: ‘QScopedPointer<QObjectData, QScopedPointerDeleter<QObjectData> > QObject::d_ptr’ is protected
.moc/release-shared/moc_qgtkstyle.cpp:59: error: within this context
/usr/include/qt4/QtCore/qobject.h:296: error: invalid use of non-static data member ‘QObject::d_ptr’
.moc/release-shared/moc_qgtkstyle.cpp:59: error: from this location
.moc/release-shared/moc_qgtkstyle.cpp: At global scope:
.moc/release-shared/moc_qgtkstyle.cpp:62: error: ‘QGtkStyle’ has not been declared
.moc/release-shared/moc_qgtkstyle.cpp: In function ‘void* qt_metacast(const char*)’:
.moc/release-shared/moc_qgtkstyle.cpp:66: error: expected type-specifier before ‘QGtkStyle’
.moc/release-shared/moc_qgtkstyle.cpp:66: error: expected ‘>’ before ‘QGtkStyle’
.moc/release-shared/moc_qgtkstyle.cpp:66: error: expected ‘(’ before ‘QGtkStyle’
.moc/release-shared/moc_qgtkstyle.cpp:66: error: ‘QGtkStyle’ was not declared in this scope
.moc/release-shared/moc_qgtkstyle.cpp:66: error: expected primary-expression before ‘>’ token
.moc/release-shared/moc_qgtkstyle.cpp:66: error: invalid use of ‘this’ in non-member function
.moc/release-shared/moc_qgtkstyle.cpp:66: error: expected ‘)’ before ‘;’ token
.moc/release-shared/moc_qgtkstyle.cpp:67: error: cannot call member function ‘virtual void* QCleanlooksStyle::qt_metacast(const char*)’ without object
.moc/release-shared/moc_qgtkstyle.cpp: At global scope:
.moc/release-shared/moc_qgtkstyle.cpp:70: error: ‘QGtkStyle’ has not been declared
.moc/release-shared/moc_qgtkstyle.cpp: In function ‘int qt_metacall(QMetaObject::Call, int, void**)’:
.moc/release-shared/moc_qgtkstyle.cpp:72: error: cannot call member function ‘virtual int QCleanlooksStyle::qt_metacall(QMetaObject::Call, int, void**)’ without object
.moc/release-shared/moc_qgtkstyle.cpp:77: error: expected type-specifier before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:77: error: expected ‘>’ before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:77: error: expected ‘(’ before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:77: error: expected primary-expression before ‘)’ token
.moc/release-shared/moc_qgtkstyle.cpp:77: error: ‘StandardPixmap’ was not declared in this scope
.moc/release-shared/moc_qgtkstyle.cpp:79: error: expected type-specifier before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:79: error: expected ‘>’ before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:79: error: expected ‘(’ before ‘StandardPixmap’
.moc/release-shared/moc_qgtkstyle.cpp:79: error: expected primary-expression before ‘)’ token
.moc/release-shared/moc_qgtkstyle.cpp:79: error: ‘StandardPixmap’ was not declared in this scope
make: *** [.obj/release-shared/moc_qgtkstyle.o] Error 1
emake failed

qt-gui and cairo are already merged with the qt4 and gtk USE flags set:

e6400 ~ # emerge -pv qt-gui cairo

These are the packages that would be merged, in order:

Calculating dependencies... done!
[ebuild   R   ] x11-libs/qt-gui-4.6.3  USE="accessibility cups dbus exceptions glib gtk mng qt3support tiff xinerama (-aqua) -debug -nas -nis -pch -raster -trace" 0 kB
[ebuild   R   ] x11-libs/cairo-1.10.0-r3  USE="X opengl qt4 svg (-aqua) -debug -directfb -doc (-drm) (-gallium) -openvg -static-libs -xcb" 0 kB

Total: 2 packages (2 reinstalls), Size of downloads: 0 kB
e6400 ~ # emerge --info
Portage 2.2_rc80 (default/linux/amd64/10.0, gcc-4.4.4, glibc-2.12.1-r1, 2.6.32-gentoo-r16 x86_64)
=================================================================
System uname: Linux-2.6.32-gentoo-r16-x86_64-Intel-R-_Core-TM-2_CPU_6400_@_2.13GHz-with-gentoo-2.0.1
Timestamp of tree: Mon, 13 Sep 2010 03:20:01 +0000
app-shells/bash:     4.1_p7
dev-java/java-config: 2.1.11
dev-lang/python:     2.6.5-r3, 3.1.2-r4
dev-util/cmake:      2.8.1-r2
sys-apps/baselayout: 2.0.1
sys-apps/openrc:     0.6.3
sys-apps/sandbox:    2.3-r1
sys-devel/autoconf:  2.13, 2.67
sys-devel/automake:  1.8.5-r4, 1.9.6-r3, 1.10.3, 1.11.1
sys-devel/binutils:  2.20.1-r1
sys-devel/gcc:       4.3.5, 4.4.4-r1
sys-devel/gcc-config: 1.4.1
sys-devel/libtool:   2.2.10
sys-devel/make:      3.81-r2
virtual/os-headers:  2.6.35 (sys-kernel/linux-headers)
ACCEPT_KEYWORDS="amd64 ~amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -march=core2 -pipe -fomit-frame-pointer"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/X11/xkb /usr/share/config /var/lib/hsqldb"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5/ext-active/ /etc/php/cgi-php5/ext-active/ /etc/php/cli-php5/ext-active/ /etc/portage /etc/revdep-rebuild /etc/sandbox.d /etc/splash /etc/terminfo /etc/texmf/language.dat.d /etc/texmf/language.def.d /etc/texmf/updmap.d /etc/texmf/web2c"
CXXFLAGS="-O2 -march=core2 -pipe -fomit-frame-pointer"
DISTDIR="/usr/portage/distfiles"
FEATURES="assume-digests distlocks fixlafiles fixpackages news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch"
GENTOO_MIRRORS="http://www.cyberuse.com/gentoo/ http://distro.ibiblio.org/pub/linux/distributions/gentoo/ http://gentoo.netnitco.net http://gentoo.wetzlmayr.com/ http://gentoo.mirrors.tds.net/gentoo"
LANG="en_US.UTF-8"
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="en"
MAKEOPTS="-j3"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_EXTRA_OPTS="--progress"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/var/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage"
SYNC="rsync://rsync.namerica.gentoo.org/gentoo-portage"
USE="64bit X a52 aac acl acpi alsa amd64 apache2 artworkextra asf audiofile automount avahi berkdb bindist branding bzip2 cairo caps cdda cddb cdio cdparanoia cdr cli consolekit cracklib crypt cups curl cxx dbus device-mapper dri dvd dvdr dvi encode escreen fbcondecor ffmpeg firefox flac foomaticdb fortran fuse gd gdbm gdu gif gimp glib glibc-omitfp gmp gnome gnomecd gnutls google-gadgets gphoto2 gpm gstreamer gtk hal iconv id3tag ieee1394 ifp imagemagick imlib inotify ipv6 ithreads java java5 java6 jpeg jpeg2k kde lame laptop latex libnotify libwww lm_sensors logrotate lua lzma mad md5sum mdnsresponder-compat mmap mmx mng modules mp2 mp3 mp4 mpeg mplayer mtp mudflap multilib musicbrainz mysql nautilus ncurses nls nptl nptlonly nsplugin offensive ogg openal openexr opengl openmp pam pcre pdf perl php plotutils png policykit posix ppds pppd python qt3support qt4 quicktime rar rdp readline reflection rtc ruby samba scanner sdl semantic-desktop session sift skins smbclient sndfile spell sqlite sse sse2 ssl ssse3 startup-notification svg sysfs tcpd theora threads tiff transcode truetype twolame unicode usb vcd vim-with-x vnc vorbis webkit wmf wxwidgets wxwindows x264 xcomposite xine xinerama xml xorg xpm xscreensaver xulrunner xv xvid xvmc zip zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" CAMERAS="canon" ELIBC="glibc" INPUT_DEVICES="mouse keyboard evdev" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="en" RUBY_TARGETS="ruby18" SANE_BACKENDS="genesys" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account" 
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, FFLAGS, INSTALL_MASK, LC_ALL, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS

Comment 4 Greg Turner 2010-09-13 10:03:00 UTC
This has sort-of already been stated, but to be clear, a quick-and-dirty workaround would be something like:

# USE="-qt4" emerge -1 cairo
# emerge -1 qt-gui
# emerge -1 cairo

I don't understand the kde build system nearly well enough to fix bugs like this (where does the makefile keep regenerating from? lol), but the above works for me until some more clueful person can fix the real problem.
Comment 5 Juergen Rose 2010-09-14 10:19:08 UTC
I just hit the same issue, when I did 'emerge -uveDN system' on two boxes.
At the first box qt-gui-4.6.3 and of the second box qt-gui-4.7.0_rc1 failed.
The workaround of comment #4 with a subsequent 'emerge -vueND --resume --skipfirst system' solved the problem temporarily.
Comment 6 thomas 2010-09-16 15:30:16 UTC
Same happened to me when upgrading from KDE 4.4.5 to 4.5.1 (qt 4.5.2 -> 4.5.3).

This worked:
USE="-qt4" emerge -1 cairo
emerge --ask --update --deep --newuse world

It recompiled cairo with qt4 automatically in the 2nd step after successfully compiling qt-gui.
Comment 7 thomas 2010-09-16 15:31:04 UTC
Correction: I meant qt 4.6.2 -> 4.6.3.
Comment 8 Robert Cabrera 2010-09-19 11:22:03 UTC
Me too on my ~86 laptop.

The workaround gets things to build, but there has go to be a better fix.
Comment 9 Davide Pesavento gentoo-dev 2010-09-22 10:14:23 UTC
*** Bug 338283 has been marked as a duplicate of this bug. ***
Comment 10 Markus Meier gentoo-dev 2010-09-26 11:24:00 UTC
*** Bug 338774 has been marked as a duplicate of this bug. ***
Comment 11 Davide Pesavento gentoo-dev 2010-09-26 18:54:39 UTC
*** Bug 338298 has been marked as a duplicate of this bug. ***
Comment 12 Alex Alexander (RETIRED) gentoo-dev 2010-11-10 11:18:26 UTC
I finally got around to fixing this. I removed support for the gtk style from
qt-gui and created a new ebuild for it, x11-themes/qgtkstyle, which is not
affected by cairo[qt4].

The new, just unmasked Qt 4.7.1 contains the fix.
Stable users will have to wait until x11-libs/qt-gui-4.6.3-r1 and
x11-themes/qgtkstyle-4.6.3 are marked stable - bug #341703

Don't forget to install x11-themes/qgtkstyle if you need Qt's GTK style!

Thank you for your patience :)
Comment 13 Alex Alexander (RETIRED) gentoo-dev 2010-11-10 12:27:57 UTC
Note: if you're one of the unlucky few who synced right after I updated this bug, qt-gui may fail for you. You'll have to re-sync and try again. The initial commit worked on my main system for some bizarre reason so I missed it at first, then it suddenly occurred to me that gtkstyle wasn't explicitly disabled and it was - you guessed it - enabled by default. It's all fixed now.

Thank you for your patience, enjoy your non-cairo[qt4]-blocking Qt :)
Comment 14 Alex Alexander (RETIRED) gentoo-dev 2010-11-11 10:11:38 UTC
*** Bug 338479 has been marked as a duplicate of this bug. ***
Comment 15 Kacper Kopczynski 2010-11-11 11:59:13 UTC
I can't remember having "qt4" use flag ever an option to enable for x11-libs/cairo, ever. I sync every week or so, and it has been a looooong time since cairo was recompiled.

I just synced (emerge --sync) and checked that only cairo-1.10.0-r3 has this use flag:
---------------------
emerge =cairo-1.10.0-r3 -pv

These are the packages that would be merged, in order:

Calculating dependencies... done!

!!! All ebuilds that could satisfy "=x11-libs/cairo-1.10.0-r3" have been masked.
!!! One of the following masked packages is required to complete your request:
- x11-libs/cairo-1.10.0-r3 (masked by: ~x86 keyword)


For more information, see the MASKED PACKAGES section in the emerge
man page or refer to the Gentoo Handbook.

---------------------

Now, because of this "solution", I can't use my gtk style in qt.

I do have qt-gui-4.6.3-r1, qgtkstyle-4.6.3 (emerged last night). qtconfig does not list gtk style, as it has previously.

Can someone help me with this?
Comment 16 Alex Alexander (RETIRED) gentoo-dev 2010-11-11 13:29:10 UTC
sigh... fixed one problem, created another. I'll look into it. Sorry for the trouble.
Comment 17 nE0sIghT 2010-11-12 20:06:43 UTC
(In reply to comment #15)
> Now, because of this "solution", I can't use my gtk style in qt.

Same here with qt-4.7.1


emerge --info
Portage 2.2.0_alpha4 (default/linux/amd64/10.0, gcc-4.5.1, glibc-2.11.2-r3, 2.6.36-gentoo x86_64)
=================================================================
System uname: Linux-2.6.36-gentoo-x86_64-AMD_Athlon-tm-_64_X2_Dual_Core_Processor_5200+-with-gentoo-2.0.1
Timestamp of tree: Fri, 12 Nov 2010 17:15:02 +0000
ccache version 2.4 [enabled]
app-shells/bash:     4.1_p7
dev-java/java-config: 2.1.11
dev-lang/python:     2.6.5-r3, 3.1.2-r4
dev-util/ccache:     2.4-r7
dev-util/cmake:      2.8.1-r2
sys-apps/baselayout: 2.0.1-r1
sys-apps/openrc:     0.6.3
sys-apps/sandbox:    2.3-r1
sys-devel/autoconf:  2.13, 2.65-r1
sys-devel/automake:  1.7.9-r2, 1.8.5-r4, 1.9.6-r3, 1.10.3, 1.11.1
sys-devel/binutils:  2.20.1-r1
sys-devel/gcc:       4.5.1
sys-devel/gcc-config: 1.4.1
sys-devel/libtool:   2.2.10
sys-devel/make:      3.81-r2
virtual/os-headers:  2.6.35 (sys-kernel/linux-headers)
Repositories: gentoo vortex php pcsx2 desktop-effects sunrise arcon rion oss-overlay qutim
ACCEPT_KEYWORDS="amd64"
ACCEPT_LICENSE="*"
CBUILD="x86_64-pc-linux-gnu"
CFLAGS="-O2 -march=native -pipe -fomit-frame-pointer -ftree-vectorize -floop-interchange -floop-strip-mine -floop-block -ftree-loop-distribution"
CHOST="x86_64-pc-linux-gnu"
CONFIG_PROTECT="/etc /usr/share/X11/xkb /usr/share/openvpn/easy-rsa"
CONFIG_PROTECT_MASK="/etc/ca-certificates.conf /etc/env.d /etc/env.d/java/ /etc/fonts/fonts.conf /etc/gconf /etc/gentoo-release /etc/php/apache2-php5.3/ext-active/ /etc/php/cgi-php5.3/ext-active/ /etc/php/cli-php5.3/ext-active/ /etc/revdep-rebuild /etc/sandbox.d /etc/terminfo"
CXXFLAGS="-O2 -march=native -pipe -fomit-frame-pointer -ftree-vectorize -floop-interchange -floop-strip-mine -floop-block -ftree-loop-distribution"
DISTDIR="/usr/portage/distfiles"
FEATURES="assume-digests binpkg-logs ccache distlocks fixlafiles fixpackages news parallel-fetch preserve-libs protect-owned sandbox sfperms strict unknown-features-warn unmerge-logs unmerge-orphans userfetch"
GENTOO_MIRRORS="ftp://ftp.san.ru/unix/linux/gentoo/gentoo-distfiles http://mirrors.sgu.ru/gentoo/distfiles http://oss.mexmat.sgu.ru/soft/unix/gentoo/distfiles"
LANG="ru_RU.UTF-8"
LC_ALL=""
LDFLAGS="-Wl,-O1 -Wl,--as-needed"
LINGUAS="ru en"
MAKEOPTS="-j3"
PKGDIR="/usr/portage/packages"
PORTAGE_CONFIGROOT="/"
PORTAGE_RSYNC_OPTS="--recursive --links --safe-links --perms --times --compress --force --whole-file --delete --stats --timeout=180 --exclude=/distfiles --exclude=/local --exclude=/packages"
PORTAGE_TMPDIR="/home/tmp"
PORTDIR="/usr/portage"
PORTDIR_OVERLAY="/usr/local/portage /var/lib/layman/php /var/lib/layman/pcsx2 /usr/local/portage/layman/desktop-effects /usr/local/portage/layman/sunrise /usr/local/portage/layman/arcon /usr/local/portage/layman/rion /usr/local/portage/layman/oss-overlay /usr/local/portage/layman/qutim"
SYNC="rsync://rsync.europe.gentoo.org/gentoo-portage"
USE="3dnow 3dnowext 7zip X a52 aac aalib acl acpi alisp alsa amd64 applet archive ares artworkextra audiofile automount bazaar berkdb bittorrent bittorrent-external branding bzip2 cairo caps cdr cdrtools chardet chdir cjk cli consolekit cover cracklib crypt css cue cups cupsddk curl custom-optimization cvs cxx darcs dbus device-mapper dga dht dirac directfb disk-partition divx djvu dri dv dvd dvdr enca encode exif extensions extras facedetect fat ffmpeg fileinfo firefox flac fontconfig fortran frei0r fts3 fuse gd gdbm gdu gif glade glib glitz gnome gnome-keyring gpm graphite grub gstreamer gtk gzip hddtemp iconv icq icu id3tag idle idn inifile intl jabber java java6 javascript joystick jpeg jpeg2k kate kvm ladspa lame lcms libass libcaca libnotify libsamplerate libtiger lights lirc lm_sensors loop-aes lucene lyrics lzma lzo mad matroska melt mercurial mikmod mmx mmxext mng modules mp2 mp3 mp4 mp4live mpeg mpeg2 mplayer mpu401 mtp mudflap multilib musepack mysql mysqli nautilus ncurses netplay network nls nptl nptlonly nsplugin nss ntfs nvidia offensive ogg ogm oodict openal opencore-amr opengl openmp openssl opensslcrypt optimization optimized-qmake pam parse-clocks pcf pch pcre pdo perl php png policykit ppds pppd projectm psf python qt3support qt4 quicktime rar readline realmedia rtsp ru-dv ru-g ru-i ru-k sasl scale0tilt screenshot sdl secure-delete session slang slp smp sndfile sound sounds speex spell sqlite sqlite3 sse sse2 sse3 ssl stream strong-optimization subtitles svg sysfs t1lib taglib tcpd textures theora threads thunderbird tiff timidity tls toolbar trayicon truetype tta twolame udev unicode unzip usb v4l v4l2 vamp vdpau vorbis vorbis-psy vpx wav wavpack wma wmp x264 xanim xattr xcb xcomposite xhtml xinetd xml xmlreader xmlrpc xmlwriter xorg xosd xpm xulrunner xv xvid zip zlib" ALSA_CARDS="ali5451 als4000 atiixp atiixp-modem bt87x ca0106 cmipci emu10k1x ens1370 ens1371 es1938 es1968 fm801 hda-intel intel8x0 intel8x0m maestro3 trident usb-audio via82xx via82xx-modem ymfpci" ALSA_PCM_PLUGINS="adpcm alaw asym copy dmix dshare dsnoop empty extplug file hooks iec958 ioplug ladspa lfloat linear meter mmap_emul mulaw multi null plug rate route share shm softvol" APACHE2_MODULES="actions alias auth_basic authn_alias authn_anon authn_dbm authn_default authn_file authz_dbm authz_default authz_groupfile authz_host authz_owner authz_user autoindex cache cgi cgid dav dav_fs dav_lock deflate dir disk_cache env expires ext_filter file_cache filter headers include info log_config logio mem_cache mime mime_magic negotiation rewrite setenvif speling status unique_id userdir usertrack vhost_alias" COLLECTD_PLUGINS="df interface irq load memory rrdtool swap syslog" ELIBC="glibc" GPSD_PROTOCOLS="ashtech aivdm earthmate evermore fv18 garmin garmintxt gpsclock itrax mtk3301 nmea ntrip navcom oceanserver oldstyle oncore rtcm104v2 rtcm104v3 sirf superstar2 timing tsip tripmate tnt ubx" INPUT_DEVICES="evdev joystick" KERNEL="linux" LCD_DEVICES="bayrad cfontz cfontz633 glk hd44780 lb216 lcdm001 mtxorb ncurses text" LINGUAS="ru en" LIRC_DEVICES="devinput" PHP_TARGETS="php5-3" QEMU_SOFTMMU_TARGETS="i386 x86_64" QEMU_USER_TARGETS="i386 x86_64" RUBY_TARGETS="ruby18" USERLAND="GNU" VIDEO_CARDS="nvidia" XTABLES_ADDONS="quota2 psd pknock lscan length2 ipv4options ipset ipp2p iface geoip fuzzy condition tee tarpit sysrq steal rawnat logmark ipmark dhcpmac delude chaos account" 
Unset:  CPPFLAGS, CTARGET, EMERGE_DEFAULT_OPTS, FFLAGS, INSTALL_MASK, PORTAGE_BUNZIP2_COMMAND, PORTAGE_COMPRESS, PORTAGE_COMPRESS_FLAGS, PORTAGE_RSYNC_EXTRA_OPTS


Comment 18 JDB 2010-11-13 20:07:37 UTC
(In reply to comment #15)
> Now, because of this "solution", I can't use my gtk style in qt.
> 
> I do have qt-gui-4.6.3-r1, qgtkstyle-4.6.3 (emerged last night). qtconfig does
> not list gtk style, as it has previously.

Same problem here too.
During the configure stage of qt-gui it mentions that support for GTK theme will not be compiled.
Comment 19 Alex Alexander (RETIRED) gentoo-dev 2010-11-13 20:57:05 UTC
the missing style issue is fixed in qgtkstyle-4.6.3-r1.

please open a new bug if you still have an issue after trying that one.

thanks :)
Comment 20 Kacper Kopczynski 2010-11-13 21:51:31 UTC
(In reply to comment #19)
> the missing style issue is fixed in qgtkstyle-4.6.3-r1.
> 
> please open a new bug if you still have an issue after trying that one.
> 
> thanks :)
> 

It works, thanks :)
Comment 21 daemonpnz 2010-11-13 22:08:47 UTC
(In reply to comment #19)
> the missing style issue is fixed in qgtkstyle-4.6.3-r1.
> 
> please open a new bug if you still have an issue after trying that one.
> 
> thanks :)
> 

qgtkstyle-4.7.1-r1 works for me. Thanks :)